from libavg import avg, player as avgplayer
from menu.Button import Button
from menu.StyleDefinitions import StyleDefinitions

class Map():

    def __init__(self,parentDiv):
        self.__parent = parentDiv

        self.__div = avg.DivNode(pos=(0, 0), parent=self.__parent)

        self.__center = (self.__parent.resX * 0.5, self.__parent.resY * 0.5)

        self.__background = avg.ImageNode(pos=self.__div.pos, href="../assets/thedarkness.png", size=(self.__parent.resX,self.__parent.resY), parent=self.__div)

        self.__mapPiece1 = avg.ImageNode(pos=(self.__center[0] - 500, self.__center[1] - 500), href="../assets/MapPieces/MapPiece1.png", opacity=0.0, parent=self.__div)
        self.__mapPiece2 = avg.ImageNode(pos=(self.__center[0] + 200, self.__center[1] - 500), href="../assets/MapPieces/MapPiece2.png", opacity=0.0, parent=self.__div)
        self.__mapPiece3 = avg.ImageNode(pos=(self.__center[0] - 500, self.__center[1]), href="../assets/MapPieces/MapPiece3.png", opacity=0.0, parent=self.__div)
        self.__mapPiece4 = avg.ImageNode(pos=(self.__center[0] + 200, self.__center[1]), href="../assets/MapPieces/MapPiece4.png", opacity=0.0, parent=self.__div)
        self.__pieces = [self.__mapPiece1, self.__mapPiece3,  self.__mapPiece4, self.__mapPiece2]

        self.__fullMap = avg.ImageNode(pos=(self.__center[0] - 400, self.__center[1] - 500), href="../assets/MapPieces/FullMap.png", opacity=0.0, parent=self.__div)

    def showPiece(self, currentLevel):
        self.__currentLevel = currentLevel-1
        self.__collected = False
        self.show()
        self.__showPieces()

    def hasShown(self):
        return self.__collected

    def __finish(self):
        self.__continueCampaignButton.unlink(True)
        self.__continueCampaignButton = None
        self.hide()
        self.__collected = True

    def __showPieces(self):
        if self.__currentLevel < 3:
            self.__mapAnim = avg.Anim.fadeIn(self.__pieces[self.__currentLevel], 1000, 1.0, stopCallback=self.__createButton)
        else:
            self.__mapAnim = avg.Anim.fadeIn(self.__pieces[self.__currentLevel], 2000, 1.0, stopCallback=self.__solve)
        avgplayer.getRootNode().subscribe(avg.Node.CURSOR_DOWN, self.__stopAnim)

    def __stopAnim(self, event):
        if self.__mapAnim:
            self.__mapAnim.abort()


    def __createButton(self):
        self.__continueCampaignButton = Button(pos=(self.__center[0] - (StyleDefinitions.BUTTON_LARGE_SIZE.x * 0.5), self.__parent.resY - StyleDefinitions.BUTTON_LARGE_SIZE.y - 20), size=StyleDefinitions.BUTTON_LARGE_SIZE, text="WEITER", textColor=StyleDefinitions.FONT_COLOR, parent=self.__parent)
        self.__continueCampaignButton.subscribe(Button.BUTTON_CLICKED, self.__finish)

    def __solve(self):
        for x in range(0, len(self.__pieces)):
            self.__pieces[x].active = False
        avg.Anim.fadeIn(self.__fullMap, 2000, 1.0, stopCallback=self.__createButton)

    def show(self, show=True):
        for x in range(0, len(self.__pieces)):
            self.__pieces[x].active = show
        self.__background.active = show
        self.__fullMap.active = show

    def hide(self):
        self.show(False)
