import random
from TileEvent import *
from Direction import *
from  random import choice


class BrokenRail(TileEvent):
    EVENT_NAME = "broken_rail"

    def __init__(self, tile):
        super(BrokenRail, self).__init__(tile)
        tile.setTexture('broken_rail')
        if choice((True, False)):
            self.__rotated = True
            tile.setRotation(tile.getRotation() + 180)
        else:
            self.__rotated = False

    def getEventName(self):
        return self.EVENT_NAME

    def isFullscreenEvent(self):
        return False

    def requiresCountdownAfterCompletion(self):
        return False

    def onInit(self, parentDiv, player):
        self.__active = True

        balance = player.balance
        playerDir = player.orientation

        if self.__rotated:
            balance *= -1.0

        if (playerDir == Direction.RIGHT or playerDir == Direction.UP) and balance > 0.0:
            self.__active = False
        elif (playerDir == Direction.LEFT or playerDir == Direction.DOWN) and balance < 0.0:
            self.__active = False

    def onDisabled(self):
        self.enable()

    def onFrame(self, dt, keystats):
        return not self.__active
