from libavg import avg
from event.TileEvent import TileEvent
from random import randrange
from math import radians

class FinalLootChest(TileEvent):
    EVENT_NAME = "final_lootchest_event"

    def getEventName(self):
        return FinalLootChest.EVENT_NAME

    def isFullscreenEvent(self):
        return True

    def requiresCountdownAfterCompletion(self):
        return False

    def __init__(self):
        pass

    def onInit(self, parentDiv):
        self.__count = 0
        self.__snowAmount = 100

        self.__mainDiv = avg.DivNode(size=parentDiv.size, parent=parentDiv)
        self.__videoFinished = False
        self.__snow = {}
        self.__lootchestImage = avg.ImageNode(size=self.__mainDiv.size, href="../assets/lootchest/lootchest_first_Frame.png", parent=self.__mainDiv)
        for x in range(0, self.__snowAmount):
            sizeX = randrange(200, 455)
            sizeY = round(sizeX * 1.38)
            angle = randrange(0, 90)
            posX = randrange(350, 1200)
            posY = randrange(300, 700)
            self.__snow[x] = avg.ImageNode(pos=(posX, posY), size=(sizeX, sizeY), angle=radians(angle), href="../assets/avalanche.png", sensitive=True, parent=self.__mainDiv)
            self.__snow[x].subscribe(avg.Node.CURSOR_DOWN, lambda e: self.__deleteSnow(e))

    def __onVideoFinished(self):
        self.__videoFinished = True
        self.__mainDiv.unlink(True)
        self.__mainDiv = None

    def __deleteSnow(self, event):
        event.node.unlink(True)
        self.__count += 1
        if self.__count == self.__snowAmount:
            self.__lootchestVideo = avg.VideoNode(size=self.__mainDiv.size, href="../assets/lootchest/lootchest.mp4",parent=self.__mainDiv)
            self.__lootchestVideo.subscribe(avg.VideoNode.END_OF_FILE, self.__onVideoFinished)
            self.__lootchestVideo.play()

    def onFrame(self, dt, keystates):
        return self.__videoFinished
