# coding=utf-8

from libavg import avg
from event.TileEvent import *
from menu.ScreenMessenger import ScreenMessenger
from item.Petroleum import Petroleum
from item.Brakefluid import Brakefluid
from item.TurnBack import TurnBackRune
from item.Ping import PingRune

class ItemHelpEvent(TileEvent):

    EVENT_NAME = "item_help_event"
    ASSET_DIR = "../assets/items/"
    ITEMS = {
        Petroleum : {"href": ASSET_DIR + "Petroleum.png", "name": "Rune der Weitsicht", "desc": "+80% größerer Lichtkreis"}
        ,Brakefluid : {"href": ASSET_DIR + "Brakefluid.png", "name": "Rune der Zurückhaltung", "desc": "+60% höhere Bremskraft"}
        ,TurnBackRune : {"href": ASSET_DIR + "turn_back.png", "name": "Rune der Umkehr", "desc": "auf der Stelle umdrehen"}
        ,PingRune : {"href": ASSET_DIR + "ping.png", "name": "Rune der Aufdeckung", "desc": "kurzes Aufblinken des Ziels auf der Minimap"}
    }

    def getEventName(self):
        return ItemHelpEvent.EVENT_NAME

    def isFullscreenEvent(self):
        return True

    def requiresCountdownAfterCompletion(self):
        return False

    def __init__(self, itemClass):
        self.__itemClass = itemClass

    def onInit(self, parentDiv):
        item = ItemHelpEvent.ITEMS[self.__itemClass]
        self.__mainDiv = avg.DivNode(size=parentDiv.size, parent=parentDiv)
        internalImageNode = avg.ImageNode(href=item["href"], size=(630, 630))
        self.__helpText = ScreenMessenger(size=self.__mainDiv.size, headline=item["name"], message=item["desc"], messageAlignment="center", destroyOnFinish=True, additionalMessageNodes=[internalImageNode], parent=self.__mainDiv)

    def onFrame(self, dt, keystates):
        return self.__helpText.isFinished()
