from libavg import avg
from Tile import *
from TileEvent import *
from math import radians

class ObstacleTile(TileFeature):
    FEATURE_NAME = "obstacle_feature"
    CONDITION_LIST = ["obstacle_large.png", "obstacle_medium.png", "obstacle_small.png"]
    NUM_CONDITION = len(CONDITION_LIST)

    def __init__(self, tile):
        super(ObstacleTile, self).__init__(tile)
        self.__active = True
        self.__currentCondition = 0
        
        worldRootNode = tile.parent
        self.__asset = tile.getTileset()
        self.__obstacleImg = avg.ImageNode(href= "../assets/" + self.__asset + "/" + ObstacleTile.CONDITION_LIST[self.__currentCondition], pos=tile.pos, size=tile.size, parent=worldRootNode)
        
        self.__obstacleImg.angle = radians(tile.getRotation())
        self.__obstacleImg.subscribe(avg.Node.CURSOR_DOWN, lambda e: self.__onCursorDown())

    def getFeatureName(self):
        return ObstacleTile.FEATURE_NAME

    def __onCursorDown(self):
        if self.__active:
            self.__currentCondition += 1
            if self.__currentCondition < ObstacleTile.NUM_CONDITION:
                self.__obstacleImg.href = "../assets/" + self.__asset + "/" + ObstacleTile.CONDITION_LIST[self.__currentCondition]
            else:
                self.__active = False
                self.__obstacleImg.active = False

    def isActivated(self):
        return self.__active

    def onDestroy(self):
        self.__obstacleImg.unlink(True)
        self.__obstacleImg = None
